package org.processmining.acceptingpetrinetdecomposer.algorithms;

import java.util.List;
import java.util.Map;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.acceptingpetrinet.models.AcceptingPetriNetArray;
import org.processmining.acceptingpetrinetdecomposer.parameters.DecomposeAcceptingPetriNetUsingActivityClusterArrayParameters;
import org.processmining.acceptingpetrinetdecomposer.strategies.DecompositionStrategyManager;
import org.processmining.activityclusterarray.models.ActivityClusterArray;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;

public class DecomposeAcceptingPetriNetUsingActivityClusterArrayAlgorithm {

	public AcceptingPetriNetArray apply(PluginContext context, AcceptingPetriNet acceptingNet,
			ActivityClusterArray clusters, DecomposeAcceptingPetriNetUsingActivityClusterArrayParameters parameters) {
		return DecompositionStrategyManager.getInstance().getStrategy(parameters.getStrategy()).apply(context, acceptingNet, clusters, parameters);
	}

	public AcceptingPetriNetArray apply(PluginContext context, AcceptingPetriNet acceptingNet,
			ActivityClusterArray clusters, DecomposeAcceptingPetriNetUsingActivityClusterArrayParameters parameters, List<Map<PetrinetNode, PetrinetNode>> parentChildMap) {
		return DecompositionStrategyManager.getInstance().getStrategy(parameters.getStrategy()).apply(context, acceptingNet, clusters, parameters, parentChildMap);
	}
}
