package org.processmining.acceptingpetrinetdecomposer.connections;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.acceptingpetrinet.models.AcceptingPetriNetArray;
import org.processmining.acceptingpetrinetdecomposer.parameters.DecomposeAcceptingPetriNetUsingActivityClusterArrayParameters;
import org.processmining.activityclusterarray.models.ActivityClusterArray;
import org.processmining.framework.connections.impl.AbstractConnection;

public class DecomposeAcceptingPetriNetUsingActivityClusterArrayConnection extends AbstractConnection {

	public final static String NET = "Net";
	public final static String CLUSTERS = "Clusters";
	public final static String NETS = "Nets";

	private DecomposeAcceptingPetriNetUsingActivityClusterArrayParameters parameters;

	public DecomposeAcceptingPetriNetUsingActivityClusterArrayConnection(AcceptingPetriNet net,
			AcceptingPetriNetArray nets, ActivityClusterArray clusters, DecomposeAcceptingPetriNetUsingActivityClusterArrayParameters parameters) {
		super("Decompose Accepting Petri Net Using Activity Cluster Array Connection");
		put(NET, net);
		put(CLUSTERS, clusters);
		put(NETS, nets);
		this.parameters = new DecomposeAcceptingPetriNetUsingActivityClusterArrayParameters(parameters);
	}

	public DecomposeAcceptingPetriNetUsingActivityClusterArrayParameters getParameters() {
		return parameters;
	}
}

