package org.processmining.acceptingpetrinetdecomposer.connections;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNetArray;
import org.processmining.acceptingpetrinetdecomposer.parameters.ValidateActivityClusterArrayParameters;
import org.processmining.activityclusterarray.models.ActivityClusterArray;
import org.processmining.framework.connections.impl.AbstractConnection;

public class ValidateActivityClusterArrayConnection extends AbstractConnection {

	public final static String CLUSTERS = "Clusters";
	public final static String NETS = "Nets";
	public final static String VALIDATEDCLUSTERS = "Validated Clusters";

	private ValidateActivityClusterArrayParameters parameters;

	public ValidateActivityClusterArrayConnection(ActivityClusterArray clusters, AcceptingPetriNetArray nets, ActivityClusterArray validatedClusters, ValidateActivityClusterArrayParameters parameters) {
		super("Validate Activity Cluster Array Connection");
		put(CLUSTERS, clusters);
		put(NETS, nets);
		put(VALIDATEDCLUSTERS, validatedClusters);
		this.parameters = new ValidateActivityClusterArrayParameters(parameters);
	}

	public ValidateActivityClusterArrayParameters getParameters() {
		return parameters;
	}
}
