package org.processmining.acceptingpetrinetdecomposer.parameters.sese;

import java.util.HashSet;
import java.util.Set;

import org.processmining.basicutils.parameters.impl.PluginParametersImpl;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class DecomposeBySESEsWithBridgingParameters extends PluginParametersImpl {
	
	private int maxSize;
	private Set<Transition> unsplittables;
	
	public DecomposeBySESEsWithBridgingParameters() {
		super();
		setMaxSize(25);
		Set<Transition> unsplittables = new HashSet<>();
		setUnsplittables(unsplittables);
	}
	
	public DecomposeBySESEsWithBridgingParameters(DecomposeBySESEsWithBridgingParameters parameters) {
		super(parameters);
		setMaxSize(parameters.maxSize);
		setUnsplittables(parameters.unsplittables);
	}

	public int getMaxSize() {
		return maxSize;
	}

	public void setMaxSize(int maxSize) {
		this.maxSize = maxSize;
	}

	public int hashCode() {
		final int prime = 3;
		int result = 1;
		result = prime * result + maxSize;
		return result;
	}
	
	public boolean equal(Object obj) {
		if (obj instanceof DecomposeBySESEsWithBridgingParameters) {
			DecomposeBySESEsWithBridgingParameters parameters = (DecomposeBySESEsWithBridgingParameters) obj;
			return maxSize == parameters.getMaxSize();
		}
		return false;
	}

	public Set<Transition> getUnsplittables() {
		return unsplittables;
	}

	public void setUnsplittables(Set<Transition> unsplittables) {
		this.unsplittables = unsplittables;
	}
	
	@Override
	public String toString() {
		String string = "";
		
		string += "Max size: " + getMaxSize();
		string += ", No. of unsplittables: " + getUnsplittables().size();
		
		return string;
	}
}
