package org.processmining.acceptingpetrinetdecomposer.strategies.impl;

import java.util.Map;
import java.util.Set;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.PetrinetEdge;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class DecompositionFilterStrategy extends DecompositionAbstractStrategy {

	public final static String NAME = "Filter out";
	
	public void apply(PluginContext context, 
			Petrinet net, Set<Transition> transitions, Set<Place> places,
			Set<PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode>> edges,
			Set<PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode>> inEdges,
			Set<PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode>> outEdges) {
		edges.addAll(inEdges);
		edges.retainAll(outEdges);
		for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> edge : edges) {
			if (edge.getSource() instanceof Transition) {
				transitions.add((Transition) edge.getSource());
				places.add((Place) edge.getTarget());
			} else {
				transitions.add((Transition) edge.getTarget());
				places.add((Place) edge.getSource());
			}
		}
	}
	
	public AcceptingPetriNet reduce(PluginContext context, AcceptingPetriNet apn, Set<Transition> sacredTransitions, Map<PetrinetNode, PetrinetNode> parentChildMapping) {
		return apn;
	}
	
	public String getName() {
		return NAME;
	}
}
