package org.processmining.acceptingpetrinetdecomposer.strategies.impl;

import java.util.Map;
import java.util.Set;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.PetrinetEdge;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class DecompositionReplaceNoReduceStrategy extends DecompositionAbstractStrategy {

	public final static String NAME = "Make invisible w/o Reduction";

	public void apply(PluginContext context, Petrinet net, Set<Transition> transitions, Set<Place> places,
			Set<PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode>> edges,
			Set<PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode>> inEdges,
			Set<PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode>> outEdges) {
		edges.addAll(net.getEdges());
		places.addAll(net.getPlaces());
		transitions.addAll(net.getTransitions());
	}

	public AcceptingPetriNet reduce(PluginContext context, AcceptingPetriNet apn, Set<Transition> sacredTransitions,
			Map<PetrinetNode, PetrinetNode> parentChildMapping) {
		return apn;
	}

	public String getName() {
		return NAME;
	}
}
