package org.processmining.acceptingpetrinetdecomposer.utils.petrinet;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.acceptingpetrinet.models.impl.AcceptingPetriNetFactory;
import org.processmining.models.graphbased.directed.DirectedGraphElement;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.impl.PetrinetFactory;
import org.processmining.models.semantics.petrinet.Marking;

public class AcceptingPetriNetUtils {

	public static AcceptingPetriNet cloneNet(AcceptingPetriNet origNet,
			Map<DirectedGraphElement, DirectedGraphElement> map) {
		Petrinet cloneNet = PetrinetFactory.clonePetrinet(origNet.getNet(), map);
		
		//Clone the Initial Marking
		Marking cloneIniM = new Marking();
		for(Place origP: origNet.getInitialMarking()){
			cloneIniM.add((Place) map.get(origP));
		}
		
		//Clone the Final Markings
		Set<Marking> cloneEndMarkings = new HashSet<Marking>();
		for(Marking origEndM: origNet.getFinalMarkings()){
			Marking cloneEndM = new Marking();
			for(Place origP: origEndM){
				cloneEndM.add((Place) map.get(origP));
			}
			cloneEndMarkings.add(cloneEndM);
		}
		
		//Construct the cloned Accepting Petri Net
		AcceptingPetriNet cloneAcceptingNet = AcceptingPetriNetFactory.createAcceptingPetriNet(cloneNet);
		cloneAcceptingNet.setInitialMarking(cloneIniM);
		cloneAcceptingNet.setFinalMarkings(cloneEndMarkings);
	
		return cloneAcceptingNet;
	}

	public static AcceptingPetriNet cloneNet(AcceptingPetriNet origNet) {
		Map<DirectedGraphElement, DirectedGraphElement> map = 
				new HashMap<DirectedGraphElement, DirectedGraphElement>();
		return cloneNet(origNet, map);
	}

}
